@isTest
private class SPCC_MassServiceEntrySheetEditCtrlXTest {

	public static Final Date startDate = Date.today();
	public static Final Date endDate = Date.today() + 1;


	@testSetup static void setup() {

		Test.startTest();

			SPCC_Engineering_Work_Request__c ewr = SPCC_TestData.createEWR('TestProject', '12345', '','Other');
			insert ewr;

			SPCC_Authorization_for_Expenditure__c afe = SPCC_TestData.createAFE('A1-F7GH56-4D-J7-K2', 'A1-F7GH56-4D-J7-K2', 'Test AFE', ewr.Id);
			insert afe;

			SPCC_Authorization_for_Expenditure__c afe2 = SPCC_TestData.createAFE('A1-F7GH56-4D-J7-K3', 'A1-F7GH56-4D-J7-K3', 'Test AFE 2', ewr.Id);
			insert afe2;

			SPCC_Cost_Element__c costElement = SPCC_TestData.createCostElement(afe.Id, 'Test Category',
														 'Test Description',
														 '6000000',
														 'Test Cost Element',
														 5000,
														 0);
			insert costElement;

			List<Account> vendorAccounts = new List<Account>();
			for(Integer i=0; i<5; i++) {
				vendorAccounts.add(SPCC_TestData.createSPCCVendor('Test Account' + i));
			}
			insert vendorAccounts;

			List<SPCC_Vendor_Account_Assignment__c> vaaAssignments = new List<SPCC_Vendor_Account_Assignment__c>();
			for(Account vendorAccount : vendorAccounts) {
				vaaAssignments.add(SPCC_TestData.createVAA(ewr.Id, vendorAccount.Id));
			}
			insert vaaAssignments;

			//PO Data
			List<SPCC_Purchase_Order__c> purchaseOrders = new List<SPCC_Purchase_Order__c>();
			for(Integer i=0; i<5; i++) {
				purchaseOrders.add(SPCC_TestData.createPO('012345678' + i,
														ewr.Id,
														afe.Id,
														vendorAccounts[0].Id,
														'Test Purchase Order',
														null));
			}
			purchaseOrders[0].Estimate_to_Complete__c = 500;
			insert purchaseOrders;

			List<SPCC_Line_Item__c> lineItems = new List<SPCC_Line_Item__c>();
			for(SPCC_Purchase_Order__c po : purchaseOrders) {
				SPCC_Line_Item__c lineItem = SPCC_TestData.createLineItem(po.Id, costElement.Id, 100, '0010', 'Test Line Item ' + po.Name);
				lineItems.add(lineItem);

                system.debug('dbg_lineItem: '+ lineItem);
			}

			insert lineItems;

			//BPO Data
			List<SPCC_Blanket_Purchase_Order__c> blanketPurchaseOrders = new List<SPCC_Blanket_Purchase_Order__c>();
			for(Integer i=0; i<5; i++) {
				blanketPurchaseOrders.add(SPCC_TestData.createBPO('111111111' + i,
																  vendorAccounts[0].Id,
																  startDate,
																  endDate));
			}

			insert blanketPurchaseOrders;

			List<SPCC_BPO_Line_Item__c> bpoLineItems = new List<SPCC_BPO_Line_Item__c>();
			for(SPCC_Blanket_Purchase_Order__c bpo : blanketPurchaseOrders) {
				SPCC_BPO_Line_Item__c bpoLineItem = SPCC_TestData.createBpoLineItem(bpo.Id, '9999999 - HI', 200, '0010', 'Test BPO Line Item ' + bpo.Name);
				bpoLineItems.add(bpoLineItem);
			}
            bpoLineItems[0].GL_Number__c = '0000000 - H';
            bpoLineItems[1].GL_Number__c = '1111111 - E';
			bpoLineItems[2].GL_Number__c = '2222222 - L';
            bpoLineItems[3].GL_Number__c = '3333333 - L';
            bpoLineItems[4].GL_Number__c = '4444444 - O';
			insert bpoLineItems;

		//Create Users in future call
		createUsers();

		Test.stopTest();

	}

	@isTest static void testRedirectToDetail() {
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
													   Start_Date__c, Status__c, Project_Type__c
												From SPCC_Engineering_Work_Request__c];

        User plUser = [SELECT Id FROM User WHERE user.LastName LIKE '%_PL'];

        Test.startTest();
			System.runAs(plUser) {
                //Set Page
                PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
                Test.setCurrentPage(pRef);

                //Create Controller
                ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
                SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);

				//Check that PL can't see SES related buttons
				System.assertEquals(false, extCtrl.isAllowedToCreateTicket);

                //Check of user allowed to view detail
				PageReference standardDetailPage = stdController.view();
				standardDetailPage.getParameters().put('nooverride', '1');
				System.assertEquals(standardDetailPage.getUrl(), extCtrl.redirectToDetail().getUrl());

				//System.assertEquals('/apex/SPCC_EWRDetail?id=' + ewr.Id, extCtrl.redirectToDetail().getUrl());
			}
        Test.stopTest();
	}
	
	
	@isTest static void testRedirectToReport() {
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
													   Start_Date__c, Status__c, Project_Type__c
												From SPCC_Engineering_Work_Request__c];

		//Assign CSR to Project
		User csrUser = [Select Id, Name
						From User
						Where LastName Like '%_CSR'];

		SPCC_CSR_Assignment__c csrAssignment = SPCC_TestData.createCSRAssignment(ewr.Id, csrUser.Id);
		
		
		Test.startTest();
			System.runAs(csrUser) {
				//Set Page
				PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
				Test.setCurrentPage(pRef);

				//Create Controller
				ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
				SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);

				//Check of user allowed to view detail
				System.assert(extCtrl.isUserAllowedToViewReport);
				//Check for redirect URL
				SPCC_Utilities.theme = 'Theme2';
				System.assertEquals(URL.getSalesforceBaseUrl().toExternalForm() + '/' + extCtrl.reportId + '?pv0=' + ewr.Name, extCtrl.redirectToReport().getUrl());
			    //No notification on success displyed
			    System.assertEquals(false, extCtrl.pageNotification.show);

				//Test lightning context
				SPCC_Utilities.theme = 'Theme4d';
				System.assertEquals('/lightning/r/Report/' + extCtrl.reportId + '/view?fv0=' + ewr.Name, extCtrl.redirectToReport().getUrl());
				//No notification on success displayed
				System.assertEquals(false, extCtrl.pageNotification.show);

				//Test other context (SF1)
				SPCC_Utilities.theme = 'Theme4t';
				System.assertEquals(null, extCtrl.redirectToReport());
				System.assertEquals(true, extCtrl.pageNotification.show);
				System.assertEquals('WARNING', extCtrl.pageNotification.getMode());
				System.assertEquals('Report is available only in Salesforce Classic or Lightning. ', extCtrl.pageNotification.message);

				//Test Filter Error
				extCtrl.reportIsValid = false;
				extCtrl.validateResult = 'filterError';
				SPCC_Utilities.theme = 'Theme3';
				System.assertEquals(null, extCtrl.redirectToReport());
				System.assertEquals(true, extCtrl.pageNotification.show);
				System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
				System.assertEquals('Invalid Report filter criteria set. First filter condition has to be EWR Name. ', extCtrl.pageNotification.message);

				//Deleted Report Check
				extCtrl.reportIsValid = false;
				extCtrl.validateResult = 'reportDoesNotExist';
				SPCC_Utilities.theme = 'Theme2';
				System.assertEquals(null, extCtrl.redirectToReport());
				System.assertEquals(true, extCtrl.pageNotification.show);
				System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
				System.assertEquals('Report does not exist or you don\'t have access to it. ', extCtrl.pageNotification.message);
			}
		Test.stopTest();
	}


	@isTest static void testControllerCRUDActions() {
		//Query Setup Data
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
													   Start_Date__c, Status__c
												From SPCC_Engineering_Work_Request__c];

		List<SPCC_Authorization_for_Expenditure__c> afe = [Select Id, Name, AFE_Number__c, Description__c
													       From SPCC_Authorization_for_Expenditure__c];

		List<SPCC_Purchase_Order__c> purchaseOrders = [Select Id, Name, Vendor_Account__r.Name
													   From SPCC_Purchase_Order__c];

		List<SPCC_Line_Item__c> lineItems = [Select Id, Name, Purchase_Order__c, Cost_Element__c,
													Committed_Amount__c, Short_Text__c, Item__c
											 From SPCC_Line_Item__c];


		//Assign CSR to Project
		User csrUser = [Select Id, Name
						From User
						Where LastName Like '%_CSR'];
		SPCC_CSR_Assignment__c csrAssignment = SPCC_TestData.createCSRAssignment(ewr.Id, csrUser.Id);
		insert csrAssignment;

			System.runAs(csrUser) {

				List<SPCC_Service_Entry_Sheet__c> serviceEntrySheets = new List<SPCC_Service_Entry_Sheet__c>();
				for(Integer i=0; i<5; i++) {
					serviceEntrySheets.add(SPCC_TestData.createSES(purchaseOrders[i].Id, lineItems[i].Id, 100+i, Date.today().addDays(-i),'12340' + i));
				}
				insert serviceEntrySheets;

				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c
									  From SPCC_Service_Entry_Sheet__c
									  Order By Date_Entered__c DESC NULLS LAST];

				SPCC_Engineering_Work_Request__c ewr2 = [Select Id, Name, EWR_Number__c, Project_Name__c,
						Start_Date__c, Status__c
				From SPCC_Engineering_Work_Request__c];

				Test.startTest();
					//Set Page
					PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
					Test.setCurrentPage(pRef);

                //Create Controller
                ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
                SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);

                //Check existing records
                System.assertEquals(purchaseOrders.size(), extCtrl.purchaseOrderMap.size());
                for(SPCC_Purchase_Order__c po : purchaseOrders) {
                    System.assertEquals(po.Vendor_Account__r.Name , extCtrl.purchaseOrderMap.get(po.Id).Vendor_Account__r.Name);
                }
				System.assert(extCtrl.isAllowedToCreateTicket);
                System.assertEquals(serviceEntrySheets.size(), extCtrl.serviceEntrySheets.size());
                for(Integer i=0; i < serviceEntrySheets.size(); i++) {
                    System.assertEquals(serviceEntrySheets[i].Purchase_Order__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Purchase_Order__c);
                    System.assertEquals(serviceEntrySheets[i].Amount__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Amount__c);
                    System.assertEquals(serviceEntrySheets[i].Date_Entered__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Date_Entered__c);
                    System.assertEquals(serviceEntrySheets[i].Ticket_Number__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Ticket_Number__c);
                    System.assertEquals('VIEW', extCtrl.serviceEntrySheets[i].getMode());
                    System.assertEquals('EXISTING', extCtrl.serviceEntrySheets[i].getState());
                    System.assertEquals(false, extCtrl.serviceEntrySheets[i].getIsChanged());
                }

                //Check Screen Options
                //System.assertEquals(purchaseOrders.size() + lineItems.size() +1, extCtrl.poAndLineItemComboOptions.size());
                System.assertEquals(purchaseOrders.size(), extCtrl.poAccountOptionsList.size());

                //Check Page Actions -- Add New Service Entry Sheet
                System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
                System.assertEquals(extCtrl.serviceEntrySheets.size(), serviceEntrySheets.size()+1);
                Integer newIndex = 0;
                System.assertEquals('EDIT', extCtrl.serviceEntrySheets[newIndex].getMode());
                System.assertEquals('CREATED', extCtrl.serviceEntrySheets[newIndex].getState());
                System.assertEquals(true, extCtrl.serviceEntrySheets[newIndex].getIsChanged());
                System.assertEquals(true, extCtrl.areChangedRecords);

                //Check Page Actions -- Remove Service Entry Sheet
                ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
                System.assertEquals(null, extCtrl.removeServiceEntrySheet());
                System.assertEquals(extCtrl.serviceEntrySheets.size(), serviceEntrySheets.size());
                System.assertEquals(false, extCtrl.areChangedRecords);

                //Check Page Actions -- Edit Service Entry Sheet
                Integer editIndex = 3;
                ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
                System.assertEquals(null, extCtrl.editServiceEntrySheet());
                System.assertEquals('EDIT', extCtrl.serviceEntrySheets[editIndex].getMode());
                System.assertEquals('EXISTING', extCtrl.serviceEntrySheets[editIndex].getState());
                System.assertEquals(false, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
                extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet.Amount__c = 1000.00;

				//check redirect to report if in edit mode
				System.assertEquals(null, extCtrl.redirectToReport());
				System.assertEquals(true, extCtrl.pageNotification.show);
				System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
				System.assertEquals('You are in Edit mode, please cancel or submit your changes first. ', extCtrl.pageNotification.message);

				System.assertEquals(null, extCtrl.saveServiceEntrySheet()); //Commit change to page
                System.assertEquals(true, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
                System.assertEquals('VIEW', extCtrl.serviceEntrySheets[editIndex].getMode());


                //Check Page Actions -- Add Description
                editIndex = 3;
                extCtrl.serviceEntrySheets.get(editIndex).serviceEntrySheet.Description__c = 'Test Description';
                ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
                System.assertEquals(null, extCtrl.showDescriptionEditPopup());
                System.assertEquals(extCtrl.serviceEntrySheets.get(editIndex).serviceEntrySheet.Id, extCtrl.descriptionPopup.ses.serviceEntrySheet.Id);
                System.assert(extCtrl.descriptionPopup.show);
                System.assertEquals('Test Description', extCtrl.descriptionPopup.oldDescription);
                System.assertEquals(null, extCtrl.saveDescriptionEditPopup());
                System.assert(!extCtrl.descriptionPopup.show);
                System.assertEquals(null, extCtrl.descriptionPopup.ses);
                System.assertEquals(null, extCtrl.showDescriptionEditPopup());
                System.assertEquals(null, extCtrl.cancelDescriptionEditPopup());
                //Check Page Actions -- Delete Service Entry Sheet
                Integer deleteIndex = 2;
                SPCC_Service_Entry_Sheet__c sesToDelete = extCtrl.serviceEntrySheets[deleteIndex].serviceEntrySheet;
                ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(deleteIndex));
                System.assertEquals(null, extCtrl.deleteServiceEntrySheet());
                System.assertEquals(1, extCtrl.serviceEntrySheetsToDelete.size());
                System.assertEquals(sesToDelete.Purchase_Order__c, sesToDelete.Purchase_Order__c);
			    System.assertEquals(null, extCtrl.submit());

                //Check Page Actions -- Submit Changes
                extCtrl.blanketPoEntry = false;
                System.assertEquals(null, extCtrl.addNewServiceEntrySheet());//Add Blank Service Entry Sheet to check error case
                System.assertEquals(null, extCtrl.submit());
                System.assertEquals(true, extCtrl.pageNotification.show);
                System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
                System.assertEquals(true, (extCtrl.pageNotification.message).contains('Please Select PO Number.'));
                System.assertEquals(null, extCtrl.saveServiceEntrySheet()); //Commit change to page
                System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
                System.assertEquals(true, (extCtrl.pageNotification.message).contains('Please Select PO Number.'));
                System.assertEquals(null, extCtrl.closeNotification());
                System.assertEquals(false, extCtrl.pageNotification.show);

                newIndex = 0;
                ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
                extCtrl.serviceEntrySheets[newIndex].poId = purchaseOrders[0].Name + ' - ' + purchaseOrders[0].Vendor_Account__r.Name + ' --- ' + lineItems[0].Item__c + '-' + lineItems[0].Short_Text__c;
                extCtrl.serviceEntrySheets[newIndex].setEstimateToFinish();

                //original value of estimate to finish
                System.assertEquals(500, [SELECT Estimate_to_Complete__c FROM SPCC_Purchase_Order__c WHERE Id =: purchaseOrders[0].Id].Estimate_to_Complete__c);
                extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = 'as34a3zss';
                extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 1000;
                extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
                extCtrl.serviceEntrySheets[newIndex].estimateToFinish = '600';
                extCtrl.serviceEntrySheets[newIndex].setNewEstimateToFinish();

                System.assertEquals(null, extCtrl.saveServiceEntrySheet());
				System.assertEquals(null, extCtrl.submit());
                System.assertEquals(true, extCtrl.pageNotification.show);
                System.assertEquals('SUCCESS', extCtrl.pageNotification.getMode());

                //new value of estimate to finish - after ses ticket submit
                System.assertEquals(600, [SELECT Estimate_to_Complete__c FROM SPCC_Purchase_Order__c WHERE Id =: purchaseOrders[0].Id].Estimate_to_Complete__c);
				System.assertEquals(null, extCtrl.noAction());
				Test.stopTest();
            }
	}



	@isTest
	static void testControllerCRUDActionsPartialSuccessSESforBPO() {

		//Query Setup Data
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
				Start_Date__c, Status__c
		From SPCC_Engineering_Work_Request__c];

		List<SPCC_Authorization_for_Expenditure__c> afe = [Select Id, Name, AFE_Number__c, Description__c
		From SPCC_Authorization_for_Expenditure__c];

		List<SPCC_Blanket_Purchase_Order__c> blanketPurchaseOrders = [Select Id, Name, Vendor_Account__r.Name
		From SPCC_Blanket_Purchase_Order__c];

		List<SPCC_BPO_Line_Item__c> bpoLineItems = [Select Id, Name, Blanket_Purchase_Order__c,Blanket_Purchase_Order__r.Name, GL_Number__c,
				Committed_Amount__c, Short_Text__c, Item__c
		From SPCC_BPO_Line_Item__c ORDER BY Blanket_Purchase_Order__r.Name ASC];

		//Assign CSR to Project
		User csrUser = [Select Id, Name
		From User
		Where LastName Like '%_CSR'];

		SPCC_CSR_Assignment__c csrAssignment = SPCC_TestData.createCSRAssignment(ewr.Id, csrUser.Id);
		insert csrAssignment;

		System.runAs(csrUser) {

            Test.startTest();

            System.assertEquals(1, [SELECT id,GL_Number__c, Label__c, AFE__c from SPCC_Cost_Element__c].Size());
            System.assertEquals(0, [SELECT Id from SPCC_Service_Entry_Sheet__c].Size());

			//Set Page
			PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
			Test.setCurrentPage(pRef);

			//Create Controller
			ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
			SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);


			//add first SES - this one won't be committed to database because of error on related GL code (missing AFE)
            extCtrl.blanketPoEntry = true;
			System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
			Integer newIndex = 0;
			ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
			extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[newIndex].Name + '-' + blanketPurchaseOrders[newIndex].Vendor_Account__r.Name + ' --- ' + bpoLineItems[newIndex].Item__c + '-' + bpoLineItems[newIndex].Short_Text__c;
            extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;
			extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = 'SES1';
			extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 1000;
			extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
			extCtrl.serviceEntrySheets[newIndex].estimateToFinish = '500';
			extCtrl.serviceEntrySheets[newIndex].setNewEstimateToFinish();
            extCtrl.serviceEntrySheets[newIndex].miscGlCode.AFE__c = null; // this will force an error for GL Code upsert (VALIDATION RULE)
            System.assertEquals(null, extCtrl.saveServiceEntrySheet());


            //add second SES - won't be committed to database because of error on SES itself
            extCtrl.blanketPoEntry = true;
            System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
            ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
            extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[1].Name + '-' + blanketPurchaseOrders[1].Vendor_Account__r.Name + ' --- ' + bpoLineItems[1].Item__c + '-' + bpoLineItems[1].Short_Text__c;
            extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;
            //extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = 'SES2';  // this will force an error for SES - required field missing
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 800;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
            System.assertEquals(null, extCtrl.saveServiceEntrySheet());


            //SES3 - will be successfully submitted
            extCtrl.blanketPoEntry = true;
            System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
            ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
            extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[2].Name + '-' + blanketPurchaseOrders[2].Vendor_Account__r.Name + ' --- ' + bpoLineItems[2].Item__c + '-' + bpoLineItems[2].Short_Text__c;
            extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = 'SES3';
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 20000;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
            System.assertEquals(null, extCtrl.saveServiceEntrySheet());


            //SES4 - will be successfully submitted
            extCtrl.blanketPoEntry = true;
            System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
            ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
            extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[3].Name + '-' + blanketPurchaseOrders[3].Vendor_Account__r.Name + ' --- ' + bpoLineItems[3].Item__c + '-' + bpoLineItems[3].Short_Text__c;
            extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = 'SES4';
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 990;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
			extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Final_Ticket__c = true; //test set final ticket
            System.assertEquals(null, extCtrl.saveServiceEntrySheet());

            //Submit all 4 SES tickets at once to test partial success
            System.assertEquals(null, extCtrl.submit());

			System.assertEquals(true, extCtrl.isErrorInDML);

            System.assertEquals(true, extCtrl.pageNotification.show);
            System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
            System.assertEquals(2, [SELECT Id from SPCC_Service_Entry_Sheet__c].Size());
            System.assertEquals(3, [SELECT Id, GL_Number__c, Label__c, AFE__c from SPCC_Cost_Element__c].Size());
            System.assertEquals(true, (extCtrl.pageNotification.message).contains('there was an error for related Cost Element 0000000 (A1-F7GH56-4D-J7-K2) which prevents SES to submit.'));
            System.assertEquals(true, (extCtrl.pageNotification.message).contains(' Required fields are missing: [Ticket_Number__c]'));
            System.assertEquals(0, [SELECT Id ,GL_Number__c, Label__c, AFE__c from SPCC_Cost_Element__c WHERE GL_Number__c = '1111111'].Size());
			System.assertEquals(true, [SELECT Id ,Final_Ticket__c FROM SPCC_Service_Entry_Sheet__c WHERE Ticket_Number__c = 'SES4'].Final_Ticket__c);

			System.assertEquals(null, extCtrl.closeNotification());

			//Update Final Ticket Indicator
			Integer editIndex = 0;
			ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
			System.assertEquals(null, extCtrl.editServiceEntrySheet());
			System.assertEquals('EDIT', extCtrl.serviceEntrySheets[editIndex].getMode());
			System.assertEquals('EXISTING', extCtrl.serviceEntrySheets[editIndex].getState());
			extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet.Final_Ticket__c = false;
			System.assertEquals(true, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
			System.assertEquals(null, extCtrl.submit());
			System.assertEquals('WARNING', extCtrl.pageNotification.getMode());
			System.assertEquals(true, (extCtrl.pageNotification.message).contains('Please <b>Save</b> your open Ticket(s) <b>before Submit</b> (Click "<b>✓</b>" mark)'));
			System.assertEquals(null, extCtrl.saveServiceEntrySheet());
			System.assertEquals(null, extCtrl.submit());

			System.assertEquals(false, [SELECT Id ,Final_Ticket__c FROM SPCC_Service_Entry_Sheet__c WHERE Ticket_Number__c = 'SES4'].Final_Ticket__c);


            //SES5 - submit ticket against the same misc GL Code
            extCtrl.blanketPoEntry = true;
            System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
            ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
            extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[2].Name + '-' + blanketPurchaseOrders[2].Vendor_Account__r.Name + ' --- ' + bpoLineItems[2].Item__c + '-' + bpoLineItems[2].Short_Text__c;
            extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = 'SES5';
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 4600;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
            System.assertEquals(null, extCtrl.saveServiceEntrySheet());
            System.assertEquals(null, extCtrl.submit());

            System.assertEquals(true, extCtrl.pageNotification.show);
            System.assertEquals('SUCCESS', extCtrl.pageNotification.getMode());
			Test.stopTest();
            System.assertEquals(3, [SELECT Id, GL_Number__c, Label__c, AFE__c from SPCC_Cost_Element__c].Size());
            System.assertEquals(3, [SELECT Id from SPCC_Service_Entry_Sheet__c].Size());
            System.assertEquals(0, [SELECT Id ,GL_Number__c, Label__c, AFE__c from SPCC_Cost_Element__c WHERE GL_Number__c = '0000000'].Size());


            //SES6 - submit 2 (SES6 & SES7) tickets against the same misc GL Code, there will be error for second ticket, gl code should not be deleted
            extCtrl.blanketPoEntry = true;
            System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
            ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
            extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[0].Name + '-' + blanketPurchaseOrders[0].Vendor_Account__r.Name + ' --- ' + bpoLineItems[0].Item__c + '-' + bpoLineItems[0].Short_Text__c;
            extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = 'SES6';
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 1050;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
            System.assertEquals(null, extCtrl.saveServiceEntrySheet());

            //SES7
            extCtrl.blanketPoEntry = true;
            System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
            ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
            extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[0].Name + '-' + blanketPurchaseOrders[0].Vendor_Account__r.Name + ' --- ' + bpoLineItems[0].Item__c + '-' + bpoLineItems[0].Short_Text__c;
            extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;
            //extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = 'SES7'; //this will force an error
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 2200;
            extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();

            System.assertEquals(null, extCtrl.saveServiceEntrySheet());
            System.assertEquals(null, extCtrl.submit());
			System.assertEquals(true, extCtrl.isErrorInDML);
            System.assertEquals(true, extCtrl.pageNotification.show);
            System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
            System.assertEquals(4, [SELECT Id, GL_Number__c, Label__c, AFE__c from SPCC_Cost_Element__c].Size());
            System.assertEquals(4, [SELECT Id from SPCC_Service_Entry_Sheet__c].Size());
            System.assertEquals(1, [SELECT Id ,GL_Number__c, Label__c, AFE__c from SPCC_Cost_Element__c WHERE GL_Number__c = '0000000'].Size());

			System.assertEquals(null, extCtrl.closeNotification());

            //Test delete SES
            Integer deleteIndex = 0;
            SPCC_Service_Entry_Sheet__c sesToDelete = extCtrl.serviceEntrySheets[deleteIndex].serviceEntrySheet;
            ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(deleteIndex));
            System.assertEquals(null, extCtrl.deleteServiceEntrySheet());
            System.assertEquals(1, extCtrl.serviceEntrySheetsToDelete.size());
            System.assertEquals(null, extCtrl.submit());
			System.assertEquals(null, extCtrl.submit());
			System.assertEquals('INFO', extCtrl.pageNotification.getMode());
			System.assertEquals(true, (extCtrl.pageNotification.message).contains('No changes to Submit'));
            System.assertEquals(3, [SELECT Id from SPCC_Service_Entry_Sheet__c].Size());

			//Test duplication ticket in current set
			editIndex = 0;
			ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
			System.assertEquals(null, extCtrl.editServiceEntrySheet());
			System.assertEquals('EDIT', extCtrl.serviceEntrySheets[editIndex].getMode());
			System.assertEquals('EXISTING', extCtrl.serviceEntrySheets[editIndex].getState());
			extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet.Final_Ticket__c = true;
			System.assertEquals(true, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
			System.assertEquals(null, extCtrl.saveServiceEntrySheet());

			editIndex = 1;
			ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
			System.assertEquals(null, extCtrl.editServiceEntrySheet());
			System.assertEquals('EDIT', extCtrl.serviceEntrySheets[editIndex].getMode());
			System.assertEquals('EXISTING', extCtrl.serviceEntrySheets[editIndex].getState());
			extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet.Final_Ticket__c = true;
			System.assertEquals(true, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
			System.assertEquals(null, extCtrl.saveServiceEntrySheet());

			system.debug('dbg_msg_ ' + extCtrl.pageNotification.message);
			System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
            system.debug('dbg_msg_ ' + extCtrl.pageNotification.message);
			System.assertEquals(true, (extCtrl.pageNotification.message).contains('Ticket <b>SES5</b> is already marked as Final for Blanket PO <b> 1111111112</b>.'));

			editIndex = 0;
            system.debug('dbg_msg_2 ' + extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet);
			extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet.Final_Ticket__c = false;
			System.assertEquals(null, extCtrl.saveServiceEntrySheet());
			System.assertEquals(null, extCtrl.submit());
            system.debug('dbg_msg_ ' + extCtrl.pageNotification.message);
			System.assertEquals(1, [SELECT Id ,Final_Ticket__c, ticket_number__c from SPCC_Service_Entry_Sheet__c WHERE Final_Ticket__c = true].Size());
			System.assertEquals('SES5', [SELECT Id ,Final_Ticket__c, Ticket_number__c from SPCC_Service_Entry_Sheet__c WHERE Final_Ticket__c = true].Ticket_number__c);
		}
	}



	@isTest static void testAddFirstSESforPOandBPO() {
		//Query Setup Data
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
														Start_Date__c, Status__c
												From SPCC_Engineering_Work_Request__c];
		//Assign CSR to Projects
		User csrUser = [Select Id, Name
						From User
						Where LastName Like '%_CSR'];
		SPCC_CSR_Assignment__c csrAssignment = SPCC_TestData.createCSRAssignment(ewr.Id, csrUser.Id);
		insert csrAssignment;

		Test.startTest();

			System.runAs(csrUser) {

				//Set Page
				PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
				Test.setCurrentPage(pRef);

				//Create Controller
				ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
				SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);

				System.assertEquals(0, extCtrl.serviceEntrySheets.size());

				//Check Page Actions -- Add New Service Entry Sheet
				System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);

				//Add first new SES ticket for PO
				System.assertEquals(1, extCtrl.serviceEntrySheets.size());
				Integer newIndex = 0;
				System.assertEquals('EDIT', extCtrl.serviceEntrySheets[newIndex].getMode());
				System.assertEquals('CREATED', extCtrl.serviceEntrySheets[newIndex].getState());
				System.assertEquals(true, extCtrl.serviceEntrySheets[newIndex].getIsChanged());
				System.assertEquals(true, extCtrl.areChangedRecords);

				//Check Page Actions -- Remove Service Entry Sheet
				ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
				System.assertEquals(null, extCtrl.removeServiceEntrySheet());
				System.assertEquals(0, extCtrl.serviceEntrySheets.size());
				System.assertEquals(false, extCtrl.areChangedRecords);

				//Add first new SES ticket for BPO
				extCtrl.blanketPoEntry = true;
				System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
				System.assertEquals(1, extCtrl.serviceEntrySheets.size());
				System.assertEquals('EDIT', extCtrl.serviceEntrySheets[newIndex].getMode());
				System.assertEquals('CREATED', extCtrl.serviceEntrySheets[newIndex].getState());
				System.assertEquals(true, extCtrl.serviceEntrySheets[newIndex].getIsChanged());
				System.assertEquals(true, extCtrl.areChangedRecords);

				//Check Page Actions -- Remove Service Entry Sheet
				ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
				System.assertEquals(null, extCtrl.removeServiceEntrySheet());
				System.assertEquals(0, extCtrl.serviceEntrySheets.size());
				System.assertEquals(false, extCtrl.areChangedRecords);
			}
		Test.stopTest();
	}


	@isTest static void testControllerCRUDActionsForSESAgainstBPO_noSESs() {

		//Query Setup Data
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
														Start_Date__c, Status__c
												From SPCC_Engineering_Work_Request__c];

		List<SPCC_Authorization_for_Expenditure__c> afe = [Select Id, Name, AFE_Number__c, Description__c, Engineering_Work_Request__c
														   From SPCC_Authorization_for_Expenditure__c];

		List<SPCC_Blanket_Purchase_Order__c> blanketPurchaseOrders = [Select Id, Name, Vendor_Account__r.Name
													   				  From SPCC_Blanket_Purchase_Order__c];

		List<SPCC_BPO_Line_Item__c> bpoLineItems = [Select Id, Name, Blanket_Purchase_Order__c, GL_Number__c,
															Committed_Amount__c, Short_Text__c, Item__c
													From SPCC_BPO_Line_Item__c];

		//Assign CSR to Project
		User csrUser = [Select Id, Name
						From User
						Where LastName Like '%_CSR'];

		SPCC_CSR_Assignment__c csrAssignment = SPCC_TestData.createCSRAssignment(ewr.Id, csrUser.Id);
		insert csrAssignment;

		Test.startTest();

			System.runAs(csrUser) {

				//Set Page
				PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
				Test.setCurrentPage(pRef);

				//Create Controller
				ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
				SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);

				extCtrl.blanketPoEntry = true;

				System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
				Integer newIndex = 0;
				ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
				extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[0].Name + '-' + blanketPurchaseOrders[0].Vendor_Account__r.Name + ' --- ' + bpoLineItems[0].Item__c + '-' + bpoLineItems[0].Short_Text__c;
				extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;
				extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = '00001';
				extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 1000;
				extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
				extCtrl.serviceEntrySheets[newIndex].estimateToFinish = '500';
				extCtrl.serviceEntrySheets[newIndex].setNewEstimateToFinish();

				System.assertEquals(null, extCtrl.saveServiceEntrySheet()); //Commit change to page
				System.assertEquals(true, extCtrl.serviceEntrySheets[newIndex].getIsChanged());
				System.assertEquals('VIEW', extCtrl.serviceEntrySheets[newIndex].getMode());

				System.assertEquals(0, [SELECT Id FROM SPCC_Service_Entry_Sheet__c].Size());
				System.assertEquals(null, extCtrl.submit());
				System.assertEquals(1, [SELECT Id FROM SPCC_Service_Entry_Sheet__c].Size());

				System.assertEquals(500, [SELECT BPO_Estimate_to_Complete__c FROM SPCC_Service_Entry_Sheet__c].BPO_Estimate_to_Complete__c);

				//Check Page Actions -- Edit Service Entry Sheet
				Integer editIndex = 0;
				ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
				System.assertEquals(null, extCtrl.editServiceEntrySheet());
				System.assertEquals('EDIT', extCtrl.serviceEntrySheets[editIndex].getMode());
				System.assertEquals('EXISTING', extCtrl.serviceEntrySheets[editIndex].getState());
				System.assertEquals(false, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
				extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet.Amount__c = 2000;
				extCtrl.serviceEntrySheets[editIndex].estimateToFinish = '200';
				extCtrl.serviceEntrySheets[editIndex].setNewEstimateToFinish();

				System.Debug('extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet: ' + extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet);

				System.assertEquals(null, extCtrl.saveServiceEntrySheet()); //Commit change to page
				System.assertEquals(true, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
				System.assertEquals('VIEW', extCtrl.serviceEntrySheets[editIndex].getMode());

				//Check Page Actions -- Add Description
				extCtrl.serviceEntrySheets.get(editIndex).serviceEntrySheet.Description__c = 'Test Description';
				ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
				System.assertEquals(null, extCtrl.showDescriptionEditPopup());
				System.assertEquals(extCtrl.serviceEntrySheets.get(editIndex).serviceEntrySheet.Id, extCtrl.descriptionPopup.ses.serviceEntrySheet.Id);
				System.assert(extCtrl.descriptionPopup.show);
				System.assertEquals('Test Description', extCtrl.descriptionPopup.oldDescription);
				System.assertEquals(null, extCtrl.saveDescriptionEditPopup());
				System.assert(!extCtrl.descriptionPopup.show);
				System.assertEquals(null, extCtrl.descriptionPopup.ses);
				System.assertEquals(null, extCtrl.showDescriptionEditPopup());
				System.assertEquals(null, extCtrl.cancelDescriptionEditPopup());
				System.assertEquals(null, extCtrl.submit());
				System.assertEquals(200, [SELECT BPO_Estimate_to_Complete__c FROM SPCC_Service_Entry_Sheet__c].BPO_Estimate_to_Complete__c);
			}
		Test.stopTest();
	}



	@isTest static void testControllerCRUDActionsForSESAgainstBPO_SESs() {

		//Query Setup Data
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
				Start_Date__c, Status__c
		From SPCC_Engineering_Work_Request__c];

		List<SPCC_Authorization_for_Expenditure__c> afe = [Select Id, Name, AFE_Number__c, Description__c
		From SPCC_Authorization_for_Expenditure__c];

		List<SPCC_Blanket_Purchase_Order__c> blanketPurchaseOrders = [Select Id, Name, Vendor_Account__r.Name
		From SPCC_Blanket_Purchase_Order__c];

		List<SPCC_BPO_Line_Item__c> bpoLineItems = [Select Id, Name, Blanket_Purchase_Order__c, GL_Number__c,
				Committed_Amount__c, Short_Text__c, Item__c
		From SPCC_BPO_Line_Item__c];

		//Assign CSR to Project
		User csrUser = [Select Id, Name
		From User
		Where LastName Like '%_CSR'];

		SPCC_CSR_Assignment__c csrAssignment = SPCC_TestData.createCSRAssignment(ewr.Id, csrUser.Id);
		insert csrAssignment;

		SPCC_Cost_Element__c costElement = SPCC_TestData.createCostElement(afe[0].Id, 'Test Category',
				'Test Description GL',
				'6666666',
				'Test Cost Element',
				5000,
				0);
		insert costElement;




		System.runAs(csrUser) {

				SPCC_Service_Entry_Sheet__c ses = new SPCC_Service_Entry_Sheet__c();
				ses = SPCC_TestData.createSESforBPO(blanketPurchaseOrders[0].Id, bpoLineItems[0].Id, 100, Date.today(),'1234bpo');
				ses.Cost_Element__c = costElement.Id;
				insert ses;


            Test.startTest();
			//Set Page
			PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
			Test.setCurrentPage(pRef);

			//Create Controller
			ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
			SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);

			extCtrl.blanketPoEntry = true;

			System.assertEquals(extCtrl.addNewServiceEntrySheet(), null);
			Integer newIndex = 0;
			ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(newIndex));
			extCtrl.serviceEntrySheets[newIndex].blanketPOId = blanketPurchaseOrders[0].Name + '-' + blanketPurchaseOrders[0].Vendor_Account__r.Name + ' --- ' + bpoLineItems[0].Item__c + '-' + bpoLineItems[0].Short_Text__c;

			extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Ticket_Number__c = '00001';
			extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Amount__c = 1000;
			extCtrl.serviceEntrySheets[newIndex].serviceEntrySheet.Date_Entered__c = Date.today();
			extCtrl.serviceEntrySheets[newIndex].estimateToFinish = '500';
			extCtrl.serviceEntrySheets[newIndex].setNewEstimateToFinish();

            System.assertEquals(null, extCtrl.submit());

            System.assertEquals('WARNING', extCtrl.pageNotification.getMode());

            System.assertEquals(null, extCtrl.saveServiceEntrySheet()); //Commit change to page


			System.assertEquals('ERROR', extCtrl.pageNotification.getMode());
			System.assertEquals('No Authorization For Expenditure filled. Please select AFE Number.', extCtrl.pageNotification.message);

			extCtrl.serviceEntrySheets[newIndex].afeId = afe[0].Id;

            System.assertEquals(null, extCtrl.saveServiceEntrySheet()); //Commit change to page
			System.assertEquals(null, extCtrl.submit());

			System.assertEquals(true, extCtrl.pageNotification.show);
			System.assertEquals('SUCCESS', extCtrl.pageNotification.getMode());

			//Check Page Actions -- Edit Service Entry Sheet
			Integer editIndex = 0;
			ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
			System.assertEquals(null, extCtrl.editServiceEntrySheet());
			System.assertEquals('EDIT', extCtrl.serviceEntrySheets[editIndex].getMode());
			System.assertEquals('EXISTING', extCtrl.serviceEntrySheets[editIndex].getState());
			System.assertEquals(false, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
			extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet.Amount__c = 2000;

			extCtrl.serviceEntrySheets[newIndex].setEstimateToFinish();
			//original value of estimate to finish
			System.assertEquals(500, [SELECT BPO_Estimate_to_Complete__c FROM SPCC_Service_Entry_Sheet__c][0].BPO_Estimate_to_Complete__c);

			extCtrl.serviceEntrySheets[editIndex].estimateToFinish = '200';
			extCtrl.serviceEntrySheets[editIndex].setNewEstimateToFinish();

			System.Debug('extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet: ' + extCtrl.serviceEntrySheets[editIndex].serviceEntrySheet);

			System.assertEquals(null, extCtrl.saveServiceEntrySheet()); //Commit change to page
			System.assertEquals(true, extCtrl.serviceEntrySheets[editIndex].getIsChanged());
			System.assertEquals('VIEW', extCtrl.serviceEntrySheets[editIndex].getMode());


			//Check Page Actions -- Add Description
			extCtrl.serviceEntrySheets.get(editIndex).serviceEntrySheet.Description__c = 'Test Description';
			ApexPages.currentPage().getParameters().put('sesIndex', String.valueOf(editIndex));
			System.assertEquals(null, extCtrl.showDescriptionEditPopup());
			System.assertEquals(extCtrl.serviceEntrySheets.get(editIndex).serviceEntrySheet.Id, extCtrl.descriptionPopup.ses.serviceEntrySheet.Id);
			System.assert(extCtrl.descriptionPopup.show);
			System.assertEquals('Test Description', extCtrl.descriptionPopup.oldDescription);
			System.assertEquals(null, extCtrl.saveDescriptionEditPopup());
			System.assert(!extCtrl.descriptionPopup.show);
			System.assertEquals(null, extCtrl.descriptionPopup.ses);
			System.assertEquals(null, extCtrl.showDescriptionEditPopup());
			System.assertEquals(null, extCtrl.cancelDescriptionEditPopup());
			System.assertEquals(null, extCtrl.submit());
			System.assertEquals(200, [SELECT BPO_Estimate_to_Complete__c FROM SPCC_Service_Entry_Sheet__c][0].BPO_Estimate_to_Complete__c);
            Test.stopTest();
		}

	}



	@isTest static void testControllerSortActions() {
		//Query Setup Data
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
													   Start_Date__c, Status__c
												From SPCC_Engineering_Work_Request__c];
		List<SPCC_Authorization_for_Expenditure__c> afe = [Select Id, Name, AFE_Number__c, Description__c
													 From SPCC_Authorization_for_Expenditure__c];
		List<SPCC_Purchase_Order__c> purchaseOrders = [Select Id, Name, Vendor_Account__r.Name
													   From SPCC_Purchase_Order__c];

        List<SPCC_Line_Item__c> lineItems = [Select Id, Name, Purchase_Order__c, Cost_Element__c,
                                             Committed_Amount__c, Short_Text__c, Item__c
                                             From SPCC_Line_Item__c];

		//Assign CSR to Project
		User csrUser = [Select Id, Name
						From User
						Where LastName Like '%_CSR'];
		SPCC_CSR_Assignment__c csrAssignment = SPCC_TestData.createCSRAssignment(ewr.Id, csrUser.Id);
		insert csrAssignment;

		Test.startTest();
			System.runAs(csrUser) {
				//Set Page
				PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
				Test.setCurrentPage(pRef);

				//Create Controller
				ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
				SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);

                List<SPCC_Service_Entry_Sheet__c> serviceEntrySheets = new List<SPCC_Service_Entry_Sheet__c>();
                for(Integer i=0; i<5; i++) {
                    serviceEntrySheets.add(SPCC_TestData.createSES(purchaseOrders[i].Id, lineItems[i].Id, 100+i, Date.today().addDays(-i),'12340' + i));
                }
                insert serviceEntrySheets;

				//Check existing records - Sorted By Date in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c
																	    From SPCC_Service_Entry_Sheet__c
																	    Order By Date_Entered__c DESC NULLS LAST];

				System.assertEquals(serviceEntrySheets.size(), extCtrl.serviceEntrySheets.size());
				System.assertEquals(SPCC_MassServiceEntrySheetEditCtrlX.SORT_BY_DATE, extCtrl.sortColumn);
				System.assertEquals(SPCC_MassServiceEntrySheetEditCtrlX.SORT_DESCENDING, extCtrl.sortOrder);
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Date in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Date_Entered__c Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_DATE;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Purchase Order in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.Name Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_PURCHASEORDER_NUMBER;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Purchase Order in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.Name DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_PURCHASEORDER_NUMBER;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Ticket Number in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Ticket_Number__c Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_TICKET_NUMBER;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Ticket Number in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Ticket_Number__c DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_TICKET_NUMBER;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Amount in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Amount__c Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_AMOUNT;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Amount in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Amount__c DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_AMOUNT;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Vendor in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Purchase_Order__r.Vendor_Account__r.Name
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.Vendor_Account__r.Name Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_VENDOR;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Purchase_Order__r.Vendor_Account__r.Name, 
						extCtrl.serviceEntrySheets[i].serviceEntrySheet.Purchase_Order__r.Vendor_Account__r.Name);
				}

				//Check Sorted By Vendor in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Purchase_Order__r.Vendor_Account__r.Name 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.Vendor_Account__r.Name DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_VENDOR;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Purchase_Order__r.Vendor_Account__r.Name, 
						extCtrl.serviceEntrySheets[i].serviceEntrySheet.Purchase_Order__r.Vendor_Account__r.Name);
				}

				//Check Sorted By PO Over Under in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.PO_Over_Under__c Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_PO_OVERUNDER;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By PO Over Under in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.PO_Over_Under__c DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_PO_OVERUNDER;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Incurred Cost Rate in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Line_Item__r.Incurred_Cost_Rate__c Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_INCURRED_COST_RATE;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Incurred Cost Rate in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Line_Item__r.Incurred_Cost_Rate__c DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_INCURRED_COST_RATE;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
				}

				//Check Sorted By Line Item Number in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Line_Item__r.Item__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Line_Item__r.Item__c Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_LINE_ITEM;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Line_Item__r.Item__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Line_Item__r.Item__c);
				}

				//Check Sorted By Line Item Number in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Line_Item__r.Item__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Line_Item__r.Item__c DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_LINE_ITEM;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Line_Item__r.Item__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Line_Item__r.Item__c);
				}
				
				//Check Sorted By Estimate To Finish in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Purchase_Order__r.Estimate_to_Complete__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.Estimate_to_Complete__c ASC];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_ESTIMATE_TO_FINISH;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Purchase_Order__r.Estimate_to_Complete__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Purchase_Order__r.Estimate_to_Complete__c);
				}

				//Check Sorted By Estimate To Finish in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Purchase_Order__r.Estimate_to_Complete__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.Estimate_to_Complete__c DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_ESTIMATE_TO_FINISH;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Purchase_Order__r.Estimate_to_Complete__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Purchase_Order__r.Estimate_to_Complete__c);
				}
				
				//Check Sorted By AFE Number in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Purchase_Order__r.Authorization_for_Expenditure__r.AFE_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.Authorization_for_Expenditure__r.AFE_Number__c Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_AFE_NUMBER;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Purchase_Order__r.Authorization_for_Expenditure__r.AFE_Number__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Purchase_Order__r.Authorization_for_Expenditure__r.AFE_Number__c);
				}

				//Check Sorted By AFE Numberh in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Purchase_Order__r.Authorization_for_Expenditure__r.AFE_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Purchase_Order__r.Authorization_for_Expenditure__r.AFE_Number__c DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_AFE_NUMBER;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Purchase_Order__r.Authorization_for_Expenditure__r.AFE_Number__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Purchase_Order__r.Authorization_for_Expenditure__r.AFE_Number__c);
				}	
					
				//Check Sorted By Gl Code in Ascending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Line_Item__r.Cost_Element__r.GL_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Line_Item__r.Cost_Element__r.GL_Number__c Asc NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_GL_NUMBER;SORT_ASCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Line_Item__r.Cost_Element__r.GL_Number__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Line_Item__r.Cost_Element__r.GL_Number__c);
				}

				//Check Sorted By Gl Code in Descending Order
				serviceEntrySheets = [Select Id, Name, Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
											 Line_Item__r.Cost_Element__r.GL_Number__c 
								      From SPCC_Service_Entry_Sheet__c
								      Order By Line_Item__r.Cost_Element__r.GL_Number__c DESC NULLS LAST];
				ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_GL_NUMBER;SORT_DESCENDING');
				System.assertEquals(null, extCtrl.sortServiceEntrySheets());
				for(Integer i=0; i < serviceEntrySheets.size(); i++) {
					System.assertEquals(serviceEntrySheets[i].Line_Item__r.Cost_Element__r.GL_Number__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Line_Item__r.Cost_Element__r.GL_Number__c);	
				}
			}
		Test.stopTest();
	}


	@isTest static void testControllerSortActions_BPO_SESs() {
		//Query Setup Data
		SPCC_Engineering_Work_Request__c ewr = [Select Id, Name, EWR_Number__c, Project_Name__c,
				Start_Date__c, Status__c
		From SPCC_Engineering_Work_Request__c];
		List<SPCC_Authorization_for_Expenditure__c> afe = [Select Id, Name, AFE_Number__c, Description__c
		From SPCC_Authorization_for_Expenditure__c];

		//BPO Data
		List<SPCC_Blanket_Purchase_Order__c> blanketPurchaseOrders = [Select Id, Name, Vendor_Account__r.Name
		From SPCC_Blanket_Purchase_Order__c];

		List<SPCC_BPO_Line_Item__c> bpoLineItems = [Select Id, Name, Blanket_Purchase_Order__c, GL_Number__c,
				Committed_Amount__c, Short_Text__c, Item__c
		From SPCC_BPO_Line_Item__c];

		List<SPCC_Cost_Element__c> costElements = new List<SPCC_Cost_Element__c>();
		for(Integer i=0; i<5; i++) {
			costElements.add(SPCC_TestData.createCostElement(afe[0].Id, 'Test Category',
					'Test Description GL',
					'666666' + i,
					'Test Cost Element',
					5000 + i,
					0));
		}
		insert costElements;

		//Assign CSR to Project
		User csrUser = [Select Id, Name
		From User
		Where LastName Like '%_CSR'];
		SPCC_CSR_Assignment__c csrAssignment = SPCC_TestData.createCSRAssignment(ewr.Id, csrUser.Id);
		insert csrAssignment;

		Test.startTest();
		System.runAs(csrUser) {
			//Set Page
			PageReference pRef = Page.SPCC_MassServiceEntrySheetEdit;
			Test.setCurrentPage(pRef);

			//Create Controller
			ApexPages.StandardController stdController = new ApexPages.StandardController(ewr);
			SPCC_MassServiceEntrySheetEditCtrlX extCtrl = new SPCC_MassServiceEntrySheetEditCtrlX(stdController);

			List<SPCC_Service_Entry_Sheet__c> serviceEntrySheets = new List<SPCC_Service_Entry_Sheet__c>();
			for(Integer i=0; i<5; i++) {
				serviceEntrySheets.add(SPCC_TestData.createSESforBPO(blanketPurchaseOrders[i].Id, bpoLineItems[i].Id, 100+(i*10), Date.today().addDays(-i),'12340' + i));
				serviceEntrySheets[i].Cost_Element__c = costElements[i].Id;
				serviceEntrySheets[i].BPO_Estimate_to_Complete__c = 1000 + i;
			}

			insert serviceEntrySheets;

			//Check existing records - Sorted By Date in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Date_Entered__c DESC NULLS LAST];

			System.assertEquals(serviceEntrySheets.size(), extCtrl.serviceEntrySheets.size());
			System.assertEquals(SPCC_MassServiceEntrySheetEditCtrlX.SORT_BY_DATE, extCtrl.sortColumn);
			System.assertEquals(SPCC_MassServiceEntrySheetEditCtrlX.SORT_DESCENDING, extCtrl.sortOrder);
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Date in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Date_Entered__c Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_DATE;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Blanket Purchase Order in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Blanket_Purchase_Order__r.Name ASC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_PURCHASEORDER_NUMBER;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Blanket Purchase Order in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c,Blanket_Purchase_Order__r.Name, Amount__c,
					Date_Entered__c, Ticket_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Blanket_Purchase_Order__r.Name DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_PURCHASEORDER_NUMBER;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Ticket Number in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Blanket_Purchase_Order__r.Name,
					Amount__c, Date_Entered__c, Ticket_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Ticket_Number__c Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_TICKET_NUMBER;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Ticket Number in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Ticket_Number__c DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_TICKET_NUMBER;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Amount in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Amount__c Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_AMOUNT;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Amount in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Amount__c DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_AMOUNT;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Vendor in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					Blanket_Purchase_Order__r.Vendor_Account__r.Name
			From SPCC_Service_Entry_Sheet__c
			Order By Blanket_Purchase_Order__r.Vendor_Account__r.Name Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_VENDOR;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Blanket_Purchase_Order__r.Vendor_Account__r.Name,
						extCtrl.serviceEntrySheets[i].serviceEntrySheet.Blanket_Purchase_Order__r.Vendor_Account__r.Name);
			}

			//Check Sorted By Vendor in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					Blanket_Purchase_Order__r.Vendor_Account__r.Name
			From SPCC_Service_Entry_Sheet__c
			Order By Purchase_Order__r.Vendor_Account__r.Name DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_VENDOR;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Blanket_Purchase_Order__r.Vendor_Account__r.Name,
						extCtrl.serviceEntrySheets[i].serviceEntrySheet.Blanket_Purchase_Order__r.Vendor_Account__r.Name);
			}

			//Check Sorted By PO Over Under in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					BPO_Estimate_to_Complete__c
			From SPCC_Service_Entry_Sheet__c
			Order By BPO_Estimate_to_Complete__c Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_PO_OVERUNDER;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {

				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By PO Over Under in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					BPO_Estimate_to_Complete__c
			From SPCC_Service_Entry_Sheet__c
			Order By BPO_Estimate_to_Complete__c DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_PO_OVERUNDER;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Incurred Cost Rate in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					BPO_Line_Item__r.Incurred_Cost_Rate__c
			From SPCC_Service_Entry_Sheet__c
			Order By BPO_Line_Item__r.Incurred_Cost_Rate__c Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_INCURRED_COST_RATE;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Incurred Cost Rate in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					BPO_Line_Item__r.Incurred_Cost_Rate__c
			From SPCC_Service_Entry_Sheet__c
			Order By BPO_Line_Item__r.Incurred_Cost_Rate__c DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_INCURRED_COST_RATE;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Id, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Id);
			}

			//Check Sorted By Line Item Number in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					BPO_Line_Item__r.Item__c
			From SPCC_Service_Entry_Sheet__c
			Order By BPO_Line_Item__r.Item__c Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_LINE_ITEM;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].BPO_Line_Item__r.Item__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.BPO_Line_Item__r.Item__c);
			}

			//Check Sorted By Line Item Number in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					BPO_Line_Item__r.Item__c
			From SPCC_Service_Entry_Sheet__c
			Order By BPO_Line_Item__r.Item__c DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_LINE_ITEM;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].BPO_Line_Item__r.Item__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.BPO_Line_Item__r.Item__c);
			}

			//Check Sorted By Estimate To Finish in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					BPO_Estimate_to_Complete__c
			From SPCC_Service_Entry_Sheet__c
			Order By BPO_Estimate_to_Complete__c ASC];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_ESTIMATE_TO_FINISH;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].BPO_Estimate_to_Complete__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.BPO_Estimate_to_Complete__c);
			}

			//Check Sorted By Estimate To Finish in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					BPO_Estimate_to_Complete__c
			From SPCC_Service_Entry_Sheet__c
			Order By BPO_Estimate_to_Complete__c DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_ESTIMATE_TO_FINISH;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].BPO_Estimate_to_Complete__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.BPO_Estimate_to_Complete__c);
			}

			//Check Sorted By AFE Number in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					Cost_Element__r.AFE__c
			From SPCC_Service_Entry_Sheet__c
			Order By Cost_Element__r.AFE__c Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_AFE_NUMBER;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Cost_Element__r.AFE__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Cost_Element__r.AFE__c);
			}

			//Check Sorted By AFE Numberh in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					Cost_Element__r.AFE__c
			From SPCC_Service_Entry_Sheet__c
			Order By Cost_Element__r.AFE__c DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_AFE_NUMBER;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Cost_Element__r.AFE__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Cost_Element__r.AFE__c);
			}

			//Check Sorted By Gl Code in Ascending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					Cost_Element__r.GL_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Cost_Element__r.GL_Number__c Asc NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_GL_NUMBER;SORT_ASCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Cost_Element__r.GL_Number__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Cost_Element__r.GL_Number__c);
			}

			//Check Sorted By Gl Code in Descending Order
			serviceEntrySheets = [Select Id, Name, Blanket_Purchase_Order__c, Amount__c, Date_Entered__c, Ticket_Number__c,
					Cost_Element__r.GL_Number__c
			From SPCC_Service_Entry_Sheet__c
			Order By Cost_Element__r.GL_Number__c DESC NULLS LAST];
			ApexPages.currentPage().getParameters().put('sortOptions', 'SORT_BY_GL_NUMBER;SORT_DESCENDING');
			System.assertEquals(null, extCtrl.sortServiceEntrySheets());
			for(Integer i=0; i < serviceEntrySheets.size(); i++) {
				System.assertEquals(serviceEntrySheets[i].Cost_Element__r.GL_Number__c, extCtrl.serviceEntrySheets[i].serviceEntrySheet.Cost_Element__r.GL_Number__c);
			}
		}
		Test.stopTest();
	}


	@future
	private static void createUsers() {
        VendorPortalUtility.portalExecuteTriggerCode = false;
        SPCC_TestData.createPLUser();
		SPCC_TestData.createCSRUser();
	}
}